// WinThreadsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WinThreads.h"
#include "WinThreadsDlg.h"
#include <assert.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWinThreadsDlg dialog

CWinThreadsDlg::CWinThreadsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinThreadsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinThreadsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinThreadsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinThreadsDlg)
	DDX_Control(pDX, IDC_BUTTON_KILL, m_button_kill);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_button_stop);
	DDX_Control(pDX, IDC_BUTTON_START, m_button_start);
	DDX_Control(pDX, IDC_EDIT_OUTPUT, m_edit_output);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinThreadsDlg, CDialog)
	//{{AFX_MSG_MAP(CWinThreadsDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_RADIO_IDLE, OnRadioIdle)
	ON_BN_CLICKED(IDC_RADIO_LOWEST, OnRadioLowest)
	ON_BN_CLICKED(IDC_RADIO_BELOW_NORMAL, OnRadioBelowNormal)
	ON_BN_CLICKED(IDC_RADIO_NORMAL, OnRadioNormal)
	ON_BN_CLICKED(IDC_RADIO_ABOVE_NORMAL, OnRadioAboveNormal)
	ON_BN_CLICKED(IDC_RADIO_HIGHEST, OnRadioHighest)
	ON_BN_CLICKED(IDC_RADIO_TIME_CRITICAL, OnRadioTimeCritical)
	ON_BN_CLICKED(IDC_BUTTON_KILL, OnButtonKill)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinThreadsDlg message handlers

BOOL CWinThreadsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  // initialize GUI elements
  CheckRadioButton(IDC_RADIO_IDLE, IDC_RADIO_TIME_CRITICAL, IDC_RADIO_NORMAL);
  EnableDisable(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinThreadsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinThreadsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Enable or disable GUI items depending upon whether thread is running
void CWinThreadsDlg::EnableDisable(bool running)
{
  m_button_start.EnableWindow(!running);
  m_button_stop.EnableWindow(running);
  m_button_kill.EnableWindow(running);
//  GetDlgItem(IDC_RADIO_IDLE)->EnableWindow(!running);	
//  GetDlgItem(IDC_RADIO_LOWEST)->EnableWindow(!running);	
//  GetDlgItem(IDC_RADIO_BELOW_NORMAL)->EnableWindow(!running);	
//  GetDlgItem(IDC_RADIO_NORMAL)->EnableWindow(!running);	
//  GetDlgItem(IDC_RADIO_ABOVE_NORMAL)->EnableWindow(!running);	
//  GetDlgItem(IDC_RADIO_HIGHEST)->EnableWindow(!running);	
//  GetDlgItem(IDC_RADIO_TIME_CRITICAL)->EnableWindow(!running);	
}

// Return the priority selected on the radio buttons on the GUI
CWinThreadsDlg::ThreadPriority CWinThreadsDlg::GetPriority()
{
  int id = GetCheckedRadioButton(IDC_RADIO_IDLE, IDC_RADIO_TIME_CRITICAL);
  switch (id)
  {
  case IDC_RADIO_IDLE:  return MYTHREAD_IDLE;
  case IDC_RADIO_LOWEST:  return MYTHREAD_LOWEST;
  case IDC_RADIO_BELOW_NORMAL:  return MYTHREAD_BELOW_NORMAL;
  case IDC_RADIO_NORMAL:  return MYTHREAD_NORMAL;
  case IDC_RADIO_ABOVE_NORMAL:  return MYTHREAD_ABOVE_NORMAL;
  case IDC_RADIO_HIGHEST:  return MYTHREAD_HIGHEST;
  case IDC_RADIO_TIME_CRITICAL:  return MYTHREAD_TIME_CRITICAL;
  default:  assert(0);  return static_cast<ThreadPriority>( 0 );
  }
}

void CWinThreadsDlg::OnRadioIdle() 
{
  OnPriorityChanged();
}

void CWinThreadsDlg::OnRadioLowest() 
{
  OnPriorityChanged();
}

void CWinThreadsDlg::OnRadioBelowNormal() 
{
  OnPriorityChanged();
}

void CWinThreadsDlg::OnRadioNormal() 
{
  OnPriorityChanged();
}

void CWinThreadsDlg::OnRadioAboveNormal() 
{
  OnPriorityChanged();
}

void CWinThreadsDlg::OnRadioHighest() 
{
  OnPriorityChanged();
}

void CWinThreadsDlg::OnRadioTimeCritical() 
{
  OnPriorityChanged();
}


void CWinThreadsDlg::OnButtonStart() 
{
  EnableDisable(true);
  ThreadPriority priority = GetPriority();

  // example for displaying output string -- remove this line
  m_edit_output.SetWindowText("running...");  
  
  // insert your code here
}

void CWinThreadsDlg::OnButtonStop() 
{
  EnableDisable(false);
	
  // example for displaying output string -- remove this line
  m_edit_output.SetWindowText("stopped");

  // insert your code here
}

void CWinThreadsDlg::OnButtonKill() 
{
  EnableDisable(false);
	
  // example for displaying output string -- remove this line
  m_edit_output.SetWindowText("killed");

  // insert your code here	
}

void CWinThreadsDlg::OnPriorityChanged() 
{
  ThreadPriority priority = GetPriority();
  
  // example for displaying output string -- remove these lines
  CString str;
  str.Format("priority %d", priority);  // same syntax as printf
  m_edit_output.SetWindowText(str);

  // insert your code here
}
